class PageApi < ActionWebService::API::Base
  api_method :find_all_pages, :returns => [[:int]], :expects => [{:u => :string}, {:p => :string}] 
  api_method :find_page_by_id, :expects => [{:u => :string}, {:p => :string}, {:id => :int}], :returns => [Page]
  api_method :create_page, :expects => [
  {:u => :string}, 
  {:p => :string}, 
  {:name => :string},
  {:url => :string},
  {:meta_tags => :string}, 
  {:meta_descs => :string}, 
  {:body => :string}, 
  {:behaviour => :string}, 
  {:text_filter => :string}, 
  {:show_in_menu => :bool},
  {:tags => [:int]}], :returns => [:int]
  
  api_method :destroy_page, :returns => [:bool], :expects => [{:u => :string},{:p => :string}, {:id => :int}]
  
    api_method :update_page, :expects => [
    {:u => :string}, 
    {:p => :string},
    {:id => :int},
    {:name => :string},
    {:url => :string},
    {:meta_tags => :string}, 
    {:meta_descs => :string}, 
    {:body => :string}, 
    {:behaviour => :string}, 
    {:text_filter => :string}, 
    {:show_in_menu => :bool},
    {:tags => [:int]}], :returns => [:bool]
    
  api_method :find_all_tags, :returns => [[:int]], :expects => [{:u => :string}, {:p => :string}] 
  api_method :find_tag_by_id, :expects => [{:u => :string}, {:p => :string}, {:id => :int}], :returns => [Tag]
  api_method :create_tag, :expects => [{:u => :string}, {:p => :string}, {:name => :string}, {:description => :string}, {:text_filter => :string}], :returns => [:int]
  api_method :update_tag, :expects => [{:u => :string}, {:p => :string}, {:id => :int}, {:name => :string}, {:description => :string}, {:text_filter => :string}], :returns => [:bool]
  api_method :destroy_tag,:expects => [{:u => :string}, {:p => :string}, {:id => :int}], :returns => [:bool]
  
  api_method :find_all_users, :returns => [[:int]], :expects => [{:u => :string}, {:p => :string}]
  api_method :find_user_by_id, :expects => [{:u => :string}, {:p => :string}, {:id => :int}], :returns => [User]
  api_method :create_user, :expects => [{:u => :string}, {:p => :string}, {:name => :string}, {:password => :string}, {:password_confirmation => :string}, {:email => :string}, {:first_name => :string}, {:last_name => :string}, {:description => :string}, {:photo => :string}], :returns => [:int]
  api_method :destroy_user, :returns => [:bool], :expects => [{:u => :string},{:p => :string}, {:id => :int}]
  api_method :update_user, :expects => [{:u => :string}, {:p => :string}, {:id => :int}, {:name => :string}, {:password => :string}, {:password_confirmation => :string}, {:email => :string}, {:first_name => :string}, {:last_name => :string}, {:description => :string}, {:photo => :string}], :returns => [:bool]

  api_method :find_all_feeds, :returns => [[:int]], :expects => [{:u => :string}, {:p => :string}]
  api_method :find_feed_by_id, :expects => [{:u => :string}, {:p => :string}, {:id => :int}], :returns => [Flare]
  api_method :create_feed, :expects => [{:u => :string}, {:p => :string}, {:title => :string}, {:description => :string}, {:url => :string}], :returns => [:int]
  api_method :update_feed, :expects => [{:u => :string}, {:p => :string}, {:id => :int}, {:title => :string}, {:description => :string}, {:url => :string}], :returns => [:int]
  api_method :destroy_feed, :returns => [:bool], :expects => [{:u => :string},{:p => :string}, {:id => :int}]
  
end
