class Admin::AccountsController < ApplicationController
before_filter :authorize
layout 'admin'

  def index
    list
    render :action => 'list'
  end

  def list
    @user_pages, @users = paginate :users, :per_page => 10
    
    @current_user = User.find(session[:user_id])
  end

  def show
    @user = User.find(params[:id])
  end

  def new
    @user = User.new
  end

  def create
    @user = User.new(params[:user])
    if @user.save
      logger.info "CREATED A USER: User.id #{session[:user_id]}"
      flash[:notice] = 'User was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @user = User.find(params[:id])
  end

  def update
    @user = User.find(params[:id])
    if @user.update_attributes(params[:user])
      logger.info "UPDATED A USER: User.id #{session[:user_id]}"
      flash[:notice] = 'User was successfully updated.'
      if params[:commit] == 'Save and continue editing'
      					redirect_to :action => 'edit', :id => @user
      					else
      					redirect_to :action => 'show', :id => @user
			end
    else
      render :action => 'edit'
    end
  end
  
    def update_current_user
      @user = User.find(params[:id])
      if @user.update_attributes(params[:current_user])
      logger.info "UPDATED CURRENT USER: User.id #{session[:user_id]}"
        flash[:notice] = 'User was successfully updated.'
        redirect_to :action => 'show', :id => @user
      else
        render :action => 'edit'
      end
  end

  def confirm_delete
   @user = User.find(params[:id])
  end
  
  def destroy
  if session[:user_id].to_i == params[:id].to_i
    flash[:notice] = 'Can not delete current user.'
    redirect_to :action => 'list'
  else  
    User.find(params[:id]).destroy
    logger.warn "USER DELETED: #{session[:user_id]}"
    flash[:notice] = 'User was successfully deleted.'
    redirect_to :action => 'list'
  end
    rescue
    flash[:notice] = 'Can not delete last user.'
    redirect_to :action => 'list'
  end
end
