class Admin::FeedsController < ApplicationController
before_filter :authorize, :except => [:rss, :atom]
layout 'admin'
require 'net/http'
require 'uri'


  def rss
  @feed_title = Preference.find_by_setting("feed_title").value
  @feed_description = Preference.find_by_setting("feed_description").value
  @feed_link = Preference.find_by_setting("feed_link").value
  @flares = Flare.find_all
  @flares_last = Flare.find(:first, :order => 'updated_at desc')
  render :layout => false
  end
  
  def atom
  @feed_title = Preference.find_by_setting("feed_title").value
  @feed_description = Preference.find_by_setting("feed_description").value
  @feed_link = Preference.find_by_setting("feed_link").value
  @feed_author = Preference.find_by_setting("feed_author").value
  @flares_last = Flare.find(:first, :order => 'updated_at desc')
  @flares = Flare.find_all
  render :layout => false
  end
  
  
  def index
  list
  render :action => 'list'
  end

  def return_to_main
    # If you have multiple scaffolds on the same view then you will want to change this to
    # to whatever controller/action shows all the views 
    # (ex: redirect_to :controller => 'AdminConsole', :action => 'index')
    redirect_to :action => 'index'
  end

  
  def list
    @flare_pages, @flares = paginate :flares, :order_by => (Preference.find_by_setting("feed_order_by").value + ' ' + Preference.find_by_setting("feed_display_order").value), :per_page => Preference.find_by_setting("feed_display_number").value.to_i
    @feed_title = Preference.find_by_setting("feed_title").value
    @feed_description = Preference.find_by_setting("feed_description").value
    @feed_link = Preference.find_by_setting("feed_link").value
    @feed_author = Preference.find_by_setting("feed_author").value
  end

  def new
    @flare = Flare.new

    if request.xhr?
      @temp_id = Time.new.to_i
      @headers['flare-id'] = @temp_id
      @headers['Content-Type'] = 'text/html; charset=utf-8'
    
      render :layout => false
    
      # If you want to send an error message:
      # render :inline => "Error text goes here", :layout => false, :status => 500
    end
  end

  def create
    @flare = Flare.new(params[:flare])
    if @flare.save
      if request.xhr?                                                    
        @headers['flare-id'] = @flare.id
        @headers['Content-Type'] = 'text/html; charset=utf-8'
        render :partial => 'flare', :layout => false, :locals => { :hidden => true }
      else
        return_to_main
      end
    else
      render :partial => 'form_errors', :layout => false, :status => 500 if request.xhr?
      render :action => 'new' if not request.xhr?
    end
  end

  def edit
    @flare = Flare.find(params[:id])
    render :layout => false if request.xhr?
  end

  def update
    @flare = Flare.find(params[:id])
    if @flare.update_attributes(params[:flare])
      render :partial => 'flare', :layout => false, :locals => { :hidden => true } if request.xhr?
      return_to_main if not request.xhr?
    else
      render :partial => 'form_errors', :layout => false, :status => 500 if request.xhr?
      render :action => 'edit' if not request.xhr?
    end
  end

  def destroy
    Flare.find(params[:id]).destroy
    render :nothing => true if request.xhr?
    return_to_main if not request.xhr?
  end
  
  def show
  @feed = Flare.find(params[:id])
  end
end
