require 'zip/zip'

class Admin::FileController < ApplicationController
before_filter :authorize
layout 'admin'

def index
list
render :action => 'list'
end

def list
@uploads = Upload.find(:all)
end

def destroy
Upload.find(params[:id]).destroy
logger.info "DELETED A FILE: User.Id #{session[:user_id]}"
    flash[:notice] = 'File was successfully deleted.'
    redirect_to :action => 'index'
end  

def zip
uploads = params[:files_for_zip]

if File.exist?("#{RAILS_ROOT}/public/zippedfiles.zip")
File.delete("#{RAILS_ROOT}/public/zippedfiles.zip")
end

  Zip::ZipFile.open("#{RAILS_ROOT}/public/zippedfiles.zip", Zip::ZipFile::CREATE) {
   |zipfile|
   
   for up in uploads
    @zipped = Upload.find_by_id(up)
    zipfile.add(@zipped['file'], @zipped.file)
   end
  }
  
  send_file "#{RAILS_ROOT}/public/zippedfiles.zip"
end

def new
@upload = Upload.new
end

def edit
@upload = Upload.find(params[:id])
end

def update
@upload = Upload.find(params[:id])
if @upload.update_attributes(params[:upload])
flash[:notice] = 'File was successfully updated.'
logger.info "UPDATED A FILE: User.id #{session[:user_id]}"	
	if params[:commit] == 'Save and continue editing'
	redirect_to :action => 'edit', :id => @upload
	else
	redirect_to :action => 'list'
	end
else
render :action => 'edit'
end
end

def zip2
@uploads = Upload.find(params[:id])
Zip::ZipStreamableFile.new("files.zip", @uploads.file) {
   |zipfile|
    zipfile.add(@uploads.name, @uploads.file)
    zipfile.write_to_zip_output_stream
  }
end

def create
@upload = Upload.new(params[:upload])
     if @upload.save
      logger.info "UPLOADED A FILE: UserId #{session[:user_id]}"
       flash[:notice] = 'File was successfully uploaded.'
       redirect_to :action => 'index'
     else
       render :action => 'new'
    end
end

def download
download = Upload.find(params[:id])
send_file(download.file)
end

private

def do_zip(file)
Zip::ZipStreamableFile.new("files.zip", "hi.zip") {
   |zipfile|
    zipfile.add(file.name, file.file)
    zipfile.write_to_zip_output_stream
  }
end

end
