require 'fpdf'

class Admin::ImportExportController < ApplicationController
before_filter :authorize, :except => :sitemap
layout 'admin'

def index
end

def sitemap
# implementation of Google's SiteMaps protocol
# Set the headers to reflect the type of content we're sending.
@headers['Content-Type'] = 'text/xml; charset=utf-8'
# List the objects.
@pages = Page.find(:all)
@host = request.host_with_port
# This line is not really necessary, but it makes 100% sure Rails doesn't apply a layout to the .rxml template.
render_without_layout
end

def ping_google

sitemap_uri = url_for(:controller => 'stats',
		  :action => 'sitemap',
		  :trailing_slash => false,
		  :only_path => false)
		  
escaped_sitemap_uri = URI.escape(sitemap_uri)
Net::HTTP.get('www.google.com',
	  '/webmasters/sitemaps/ping?sitemap=' +
	  escaped_sitemap_uri)
flash[:notice] = 'Pinged Google.'
redirect_to :action => 'index'

end

def download_log
send_file("#{RAILS_ROOT}/log/#{RAILS_ENV}.log")
end

def logs

end

def export_to_excel
   headers['Content-Type'] = "application/vnd.ms-excel" 
   headers['Content-Disposition'] = 'attachment; filename="excel-export.xls"'
   @records = Page.find(:all)
   render_without_layout
 end

def export_to_xml
render(:xml => Page.find_all.to_xml)
end
 
  def export_to_yalm
   goyalms = []
   Page.find_all.each do |page|
   goyalm = {}
   goyalm['name'] = page.name
   goyalm['url'] = page.url
   goyalm['meta_tags'] = page.meta_tags
   goyalm['meta_descs'] = page.meta_descs
   goyalm['created_at'] = page.created_at
   goyalm['updated_at'] = page.updated_at
   goyalm['body'] = page.body
   goyalm['body_html'] = page.body_html
   goyalm['behaviour'] = page.behaviour
   goyalm['created_by'] = page.created_by
   goyalm['updated_by'] = page.updated_by
   goyalm['text_filter'] = page.text_filter
   goyalm['show_in_menu'] = page.show_in_menu
   goyalms << goyalm
   end
   
   @response.headers["content-type"] = "text/plain"
   render :text=>goyalms.to_yaml
  end
  
  def import_from_yaml
      
 if new_pages = YAML::load( @params[:yaml_data] )
  
    new_pages.each do |page|
    goyalm = Page.new
    
   tl = Page.find_by_name(page['name'])
   unless tl.nil?
       page['name'] += " Copy 2" 
   end
   
   tl2 = Page.find_by_url(page['url'])
   unless tl2.nil?
       page['url'] += "_copy_2" 
   end
   
    goyalm.name = page['name']
    goyalm.url = page['url']
    goyalm.meta_tags = page['meta_tags']
    goyalm.meta_descs = page['meta_descs']
    goyalm.created_at = page['created_at']
    goyalm.updated_at = page['updated_at']
    goyalm.body = page['body']
    goyalm.behaviour = page['behaviour']
    goyalm.created_by = page['created_by']
    goyalm.updated_by = page['updated_by']
    goyalm.text_filter = page['text_filter']
    goyalm.show_in_menu = page['show_in_menu']
    goyalm.save
    end
    flash[:notice] = 'Yaml successfully imported.'
    redirect_to :action => 'index'
  else
    redirect_to :action => 'index'
    flash[:notice] = 'Error!'
  end
  end
  
    def pdf
    @page = Page.find(params[:page_pdf])
      send_data gen_pdf(@page.name,@page.body), :filename => "#{@page.name}.pdf", :type => "application/pdf" 
    end
  
   private
    def gen_pdf(name,body)
    
      pdf=FPDF.new
      pdf.AddPage
      # Helvetica bold 15
      pdf.SetFont('Helvetica', 'B', 14)
      	# Move to the right
      pdf.Cell(80)
      	# Title
      pdf.Cell(30, 10, name)
      	# Line break
      pdf.Ln(20)
      pdf.SetFont('Arial','',12)
      pdf.Write(5, body)
      pdf.Output 
  end
end
