class Admin::PageController < ApplicationController
before_filter :authorize
layout 'admin'

  def index
  list
  render :action=> 'list'
  end

  
  def list
  
if request.xhr?
	if @params['search']
		@mark_term = Page.find(:all, :conditions => ["name LIKE ?",'%' + @params['search'] + '%' ])
		render :partial => 'page_search', :layout => false, :locals => { :hidden => true }
	end
else	
	page_order_by = Preference.find_by_setting("page_order_by").value
	page_display_order = Preference.find_by_setting("page_display_order").value
	@page_pages, @pages = paginate :pages, :order_by => (page_order_by + ' ' + page_display_order), :per_page => Preference.find_by_setting("page_display_number").value.to_i
	
end
  end

  def add_tag
  @new_tag = Tag.new
  @new_tag.name = @params[:new_tag]
  if @new_tag.save
  render :partial => 'tags'
  else
  render :text => '<div style="color:red; weight:bold;">Please specify a unique name</div>'
  end
  
  end
  
  def show
    @page = Page.find(params[:id])
  end
  
  def new
    @page = Page.new
    
    @temp_id = Time.new.to_i
    @headers['page-id'] = @temp_id
    @headers['Content-Type'] = 'text/html; charset=utf-8'
    
    render :layout => false
    
    # If you want to send an error message:
    # render :inline => "Error text goes here", :layout => false, :status => 500
  end

  def create
    @page = Page.new(params[:page])
    @page.url = CGI::escape(@page.name.to_s.gsub(/[ ]/, '_'))
    @page.text_filter = Preference.find_by_setting("site_default_text_filter").value
    @page.created_by = User.find(session[:user_id]).name
    @page.show_in_menu = 1
    if @page.save
      logger.info "QUICK CREATED A PAGE: User.id #{session[:user_id]}"
      @headers['page-id'] = @page.id
      @headers['Content-Type'] = 'text/html; charset=utf-8'
      render :partial => 'page', :layout => false, :locals => { :hidden => true }
    else
      render :partial => 'form_errors', :layout => false, :status => 500
    end
  end

  def edit
    @page = Page.find(params[:id])
    render :layout => false
  end

  def update
    @page = Page.find(params[:id])
    @page.updated_by = User.find(session[:user_id]).name
    if @page.update_attributes(params[:page])
      logger.info "QUICK UPDATED A PAGE: User.id #{session[:user_id]}"
      render :partial => 'page', :layout => false, :locals => { :hidden => true }
    else
      render :partial => 'form_errors', :layout => false, :status => 500
    end
  end

  def destroy
    Page.find(params[:id]).destroy
    logger.info "QUICK DELETED A PAGE: User.id #{session[:user_id]}"
    render :nothing => true
  end
  
  def overlay
    @page = Page.find(params[:id])
    render(:partial => "overlay", :object => @page)
  end
  
  def delete_all
  Page.delete_all
  Tag.delete_all
  end
  
  #For Future Reference
  def add_tag_overlay
  @page = Page.find(params[:id])
  @new_tag = Tag.new
  @new_tag.name = @params[:new_tag]
  @new_tag.pages.push_with_attributes(@page)
  if @new_tag.save
   render :inline => "<% for tag in @page.tags %><%= link_to(tag.name, :controller => 'tags', :action => 'show', :id => tag) %> <% end %>"
  else
   render :text => '<div style="color:red; weight:bold;">Please specify a unique name</div>'
  end
  end
  
  def edit_overlay_body
  @page = Page.find(params[:id])
  @page.updated_by = User.find(session[:user_id]).name
  @page.body = params[:value]
  @page.save
  render :inline => "<%= @page.body_html %>"
  end
  
  def view_overlay_body
  @page = Page.find(params[:id])
  render :inline => "<%= @page.body %>"
  end
  
  def preview
   @headers["Content-Type"] = "text/html; charset=utf-8"
   @body = params[:body]
   @name = params[:name]
   @text_filter = params[:text_filter]
   render :layout => false
  end
  
  def confirm_delete
  @page = Page.find(params[:id])
  end
  
  def fdestroy
  Page.find(params[:id]).destroy
  logger.info "DELETED A PAGE: User.id #{session[:user_id]}"
      flash[:notice] = 'Page was successfully deleted.'
    redirect_to :action => 'index'
  end
  
   def fedit
      @tags = Tag.find(:all , :order => 'updated_at desc')
      @page = Page.find(params[:id])
  end
 
   def fupdate
    @tags = Tag.find(:all , :order => 'updated_at desc')
    @page = Page.find(params[:id])
    @page.updated_by = User.find(session[:user_id]).name
    @page.tags = Tag.find(params[:tag_ids]) if params[:tag_ids]
     if @page.update_attributes(params[:page])
     	logger.info "UPDATED A PAGE: User.id #{session[:user_id]}"
     		flash[:notice] = 'Page was successfully updated.'
			if params[:commit] == 'Save and continue editing'
					redirect_to :action => 'fedit', :id => @page
					else
					redirect_to :action => 'show', :id => @page
			end
     		else
     		render :action => 'fedit'
  		end
  end
  
    def fnew
    	@tags = Tag.find(:all , :order => 'updated_at desc')
        @page = Page.new
        @page.text_filter = Preference.find_by_setting("site_default_text_filter").value
        @page.show_in_menu = 1
    end
    
    def fcreate
        @tags = Tag.find(:all , :order => 'updated_at desc')
        @page = Page.new(params[:page])
        @page.created_by = User.find(session[:user_id]).name
        @page.tags = Tag.find(params[:tag_ids]) if params[:tag_ids]
        if @page.save
         logger.info "CREATED A PAGE: User.id #{session[:user_id]}"
          flash[:notice] = 'Page was successfully created.'
          redirect_to :action => 'index'
        else
          render :action => 'fnew'
        end
  end
  
end
