class Admin::TagsController < ApplicationController
before_filter :authorize
layout 'admin'
  def index
  list
  render :action => 'list'
  end


  def return_to_main
    # If you have multiple scaffolds on the same view then you will want to change this to
    # to whatever controller/action shows all the views 
    # (ex: redirect_to :controller => 'AdminConsole', :action => 'index')
    redirect_to :action => 'index'
  end

  def list
    if request.xhr?
    	if @params['search']
    		@mark_term = Tag.find(:all, :conditions => ["name LIKE ?",'%' + @params['search'] + '%'])
    		render :partial => 'tag_search', :layout => false, :locals => { :hidden => true }
    	end
    else	
    @tag_pages, @tagslist = paginate :tags, :order_by => Preference.find_by_setting("tag_order_by").value, :per_page => Preference.find_by_setting("tag_display_number").value.to_i
   
     @tags = Tag.cloud.sort_by {|t| t.name}
     total=@tags.inject(0) {|total,tag| total += tag.page_counter }
     average = total.to_f / @tags.size.to_f
     @sizes = @tags.inject({}) {|h,tag| h[tag] = (tag.page_counter.to_f / average); h} # create a percentage
     # apply a lower limit of 50% and an upper limit of 200%
     @sizes.each {|tag,size| @sizes[tag] = [[2.0/3.0, size].max, 2].min * 100}
   end
  rescue
  end
  
 def edit_overlay_description
 @tag = Tag.find(params[:id])
 @tag.description = params[:value]
 @tag.save
 render :inline => "<%= @tag.description_html %>"
 end
  
 def view_overlay_description
 @tag = Tag.find(params[:id])
 render :inline => "<%= @tag.description %>"
 end
  
  def prune_tags
  Tag.prune_tags
  flash[:notice] = 'Tags were successfully pruned.'
  redirect_to :action => 'list'
  end

  def overlay
    @tag = Tag.find(params[:id])
    render(:partial => "overlay", :object => @tag)
  end
  
  def new
    @tag = Tag.new
    @tag.text_filter = Preference.find_by_setting("site_default_text_filter").value
    if request.xhr?
      @temp_id = Time.new.to_i
      @headers['tag-id'] = @temp_id
      @headers['Content-Type'] = 'text/html; charset=utf-8'
    
      render :layout => false
    
      # If you want to send an error message:
      # render :inline => "Error text goes here", :layout => false, :status => 500
    end
  end
  
  def show
  @tag = Tag.find(params[:id])
  end

  def create
    @tag = Tag.new(params[:tag])
    if @tag.save
      if request.xhr?                                                    
        @headers['tag-id'] = @tag.id
        @headers['Content-Type'] = 'text/html; charset=utf-8'
        render :partial => 'tag', :layout => false, :locals => { :hidden => true }
      else
        return_to_main
      end
    else
      render :partial => 'form_errors', :layout => false, :status => 500 if request.xhr?
      render :action => 'new' if not request.xhr?
    end
  end

  def edit
    @tag = Tag.find(params[:id])
    render :layout => false if request.xhr?
  end

  def update
    @tag = Tag.find(params[:id])
    if @tag.update_attributes(params[:tag])
      render :partial => 'tag', :layout => false, :locals => { :hidden => true } if request.xhr?
      return_to_main if not request.xhr?
    else
      render :partial => 'form_errors', :layout => false, :status => 500 if request.xhr?
      render :action => 'edit' if not request.xhr?
    end
  end

  def destroy
    Tag.find(params[:id]).destroy
    render :nothing => true if request.xhr?
    return_to_main if not request.xhr?
  end
end
