class BackendController < ApplicationController
  web_service_api PageApi
  wsdl_service_name 'Backend'

  before_invocation :authenticate    
  web_service_scaffold :invoke
  
  def find_all_pages(u, p)
   Page.find(:all).map{ |page| page.id }
  end
  
  def find_page_by_id(u, p, id)
   Page.find(id)
  end
  
  def create_page(u, p, name, url, meta_tags, meta_descs, body, behaviour, text_filter, show_in_menu, tags)
  page = Page.new
  page.name = name
  page.url = url
  page.meta_tags = meta_tags
  page.meta_descs = meta_descs
  page.body = body
  page.behaviour = behaviour
  page.text_filter = text_filter
  page.show_in_menu = show_in_menu
  page.tags = Tag.find(tags) if tags
  if page.save
  page.id
  else
  raise "Didn't save for some reason"
  end
  end
  
  def destroy_page(u, p, id)
  page = Page.find(id)
    if page.destroy
      true
    else
      false
    end
  end
  
  def update_page(u, p, id, name, url, meta_tags, meta_descs, body, behaviour, text_filter, show_in_menu, tags)
  page = Page.find(id)
    page.name = name
    page.url = url
    page.meta_tags = meta_tags
    page.meta_descs = meta_descs
    page.body = body
    page.behaviour = behaviour
    page.text_filter = text_filter
    page.show_in_menu = show_in_menu
    page.tags = Tag.find(tags) if tags
      if page.save
        true
      else
        false
      end
  end
  
  
  def find_all_tags(u, p)
  Tag.find(:all).map{ |page| page.id }
  end
  
  def find_tag_by_id(u, p, id)
  Tag.find(id)
  end
  
  def create_tag(u, p, name, description, text_filter)
  tag = Tag.new
  tag.name = name
  tag.description = description
  tag.text_filter = text_filter
    if tag.save
     tag.id
    else
     raise "Error"
    end
  end
  
  def destroy_tag(u, p, id)
  Tag.find(id).destroy
  true
  end
  
  def update_tag(u, p, id, name, description, text_filter)
  tag = Tag.find(id)
  tag.name = name
  tag.description = description
  tag.text_filter = text_filter
    if tag.save
     true
    else
     raise "Error"
    end
  end
  
  def find_all_users(u, p)
  User.find(:all).map{ |page| page.id }
  end
  
  def find_user_by_id(u, p, id)
  User.find(id)
  end
  
  def create_user(u, p, name, password, password_confirmation, email, first_name, last_name, description, photo)
  user = User.new
  user.name = name
  user.password = password
  user.password_confirmation = password_confirmation
  user.email = email
  user.first_name = first_name
  user.last_name = last_name
  user.description = description
  user.photo = photo
    if user.save
    user.id
    else
    raise "Error"
    end
  end
  
  def destroy_user(u,p,id)
  User.find(id).destroy
  true
  end
  
  def update_user(u, p, id, name, password, password_confirmation, email, first_name, last_name, description, photo)
  user = User.find(id)
  user.name = name
  user.password = password
  user.password_confirmation = password_confirmation
  user.email = email
  user.first_name = first_name
  user.last_name = last_name
  user.description = description
  user.photo = photo
    if user.save
    true
    else
    raise "Error"
    end
  end
  
  def find_all_feeds(u, p)
  Flare.find(:all).map{ |page| page.id }
  end
  
  def find_feed_by_id(u, p, id)
  Flare.find(id)
  end
  
  def create_feed(u , p, title, description, url)
  feed = Flare.new
  feed.title = title
  feed.description = description
  feed.url = url
    if feed.save
    feed.id
    else
    raise "Error"
    end
  end
  
  def update_feed(u , p, id, title, description, url)
  feed = Flare.find(id)
  feed.title = title
  feed.description = description
  feed.url = url
    if feed.save
    true
    else
    raise "Error"
    end
  end
  
  def destroy_feed(u, p, id)
  Flare.find(id).destroy
  true
  end
  
  
  protected
  
  def authenticate(name, args)
      method = self.class.web_service_api.api_methods[name]
  
      # Coping with backwards incompatibility change in AWS releases post 0.6.2
      begin
        h = method.expects_to_hash(args)
        raise "Invalid login" unless @user=User.login(h[:u], h[:p])  
      rescue NoMethodError
        username, password = method[:expects].index(:u=>String), method[:expects].index(:p=>String)
        raise "Invalid login" unless @user = User.login(args[u], args[p])  
      end
  end
  
end
