class Page < ActiveRecord::Base
has_and_belongs_to_many :tags

validates_presence_of [:name, :url]
validates_uniqueness_of [:name, :url]
validates_format_of :url, :with => /^\w+$/
before_save :transform_html


  # get posts with more than one tag.
  # accepts an array or space separated string of tag names
  def self.find_by_tags(tags)    
    # if it's a space separated string, break it up
    tags = tags.is_a?(String) ? tags.split : tags
    
    # die if we didn't get an array
    raise MultiPostFindExpectsArray unless tags.is_a?(Array)
    
    # get all the posts containing all the tags in our list
    tags.inject(Tag.find_by_name(tags.shift).pages) do |pages, tag|
      pages = pages & Tag.find_by_name(tag).pages
    end
  end

  protected
  
  def transform_html
      self.body_html = HtmlEngine.transform(self.body, self.text_filter) unless self.body.nil?
  end
  
    
end
