class Stat < ActiveRecord::Base

LANGUAGES = { :aa  =>  'AFAR'           , 
                :ab  =>  'ABKHAZIAN'      ,  
                :af  =>  'AFRIKAANS'      ,  
                :am  =>  'AMHARIC'        ,  
                :ar  =>  'ARABIC'         ,  
                :as  =>  'ASSAMESE'       ,  
                :ay  =>  'AYMARA'         ,  
                :az  =>  'AZERBAIJANI'    ,  
                :ba  =>  'BASHKIR'        ,  
                :be  =>  'BYELORUSSIAN'   ,  
                :bg  =>  'BULGARIAN'      ,  
                :bh  =>  'BIHARI'         ,  
                :bi  =>  'BISLAMA'        ,  
                :bn  =>  'BENGALI'        ,
                :bo  =>  'TIBETAN'        ,  
                :br  =>  'BRETON'         ,  
                :ca  =>  'CATALAN'        ,  
                :co  =>  'CORSICAN'       ,  
                :cs  =>  'CZECH'          ,  
                :cy  =>  'WELSH'          ,  
                :da  =>  'DANISH'         ,  
                :de  =>  'GERMAN'         ,  
                :dz  =>  'BHUTANI'        ,  
                :el  =>  'GREEK'          ,  
                :en  =>  'ENGLISH'        ,  
                :eo  =>  'ESPERANTO'      ,  
                :es  =>  'SPANISH'        ,  
                :et  =>  'ESTONIAN'       ,  
                :eu  =>  'BASQUE'         ,  
                :fa  =>  'PERSIAN'        ,
                :fi  =>  'FINNISH'        ,  
                :fj  =>  'FIJI'           ,  
                :fo  =>  'FAROESE'        ,  
                :fr  =>  'FRENCH'         ,  
                :fy  =>  'FRISIAN'        ,  
                :ga  =>  'IRISH'          ,  
                :gd  =>  'SCOTS-GAELIC'   ,  
                :gl  =>  'GALICIAN'       ,  
                :gn  =>  'GUARANI'        ,  
                :gu  =>  'GUJARATI'       ,  
                :ha  =>  'HAUSA'          ,  
                :he  =>  'HEBREW'         ,  
                :hi  =>  'HINDI'          ,  
                :hr  =>  'CROATIAN'       ,  
                :hu  =>  'HUNGARIAN'      ,  
                :hy  =>  'ARMENIAN'       ,  
                :ia  =>  'INTERLINGUA'    ,  
                :ie  =>  'INTERLINGUE'    ,  
                :ik  =>  'INUPIAK'        ,  
                :id  =>  'INDONESIAN'     ,
                :is  =>  'ICELANDIC'      ,  
                :it  =>  'ITALIAN'        ,  
                :iu  =>  'INUKTITUT'      ,  
                :ja  =>  'JAPANESE'       ,  
                :jv  =>  'JAVANESE'       ,  
                :ka  =>  'GEORGIAN'       ,  
                :kk  =>  'KAZAKH'         ,  
                :kl  =>  'GREENLANDIC'    ,  
                :km  =>  'CAMBODIAN'      ,  
                :kn  =>  'KANNADA'        ,  
                :ko  =>  'KOREAN'         ,  
                :ks  =>  'KASHMIRI'       ,  
                :ku  =>  'KURDISH'        ,  
                :ky  =>  'KIRGHIZ'        ,  
                :la  =>  'LATIN'          ,  
                :ln  =>  'LINGALA'        ,  
                :lo  =>  'LAOTHIAN'       ,  
                :lt  =>  'LITHUANIAN'     ,  
                :lv  =>  'LATVIAN'        ,
                :mg  =>  'MALAGASY'       ,  
                :mi  =>  'MAORI'          ,  
                :mk  =>  'MACEDONIAN'     ,  
                :ml  =>  'MALAYALAM'      ,  
                :mn  =>  'MONGOLIAN'      ,  
                :mo  =>  'MOLDAVIAN'      ,  
                :mr  =>  'MARATHI'        ,  
                :ms  =>  'MALAY'          ,  
                :mt  =>  'MALTESE'        ,  
                :my  =>  'BURMESE'        ,  
                :na  =>  'NAURU'          ,  
                :ne  =>  'NEPALI'         ,  
                :nl  =>  'DUTCH'          ,  
                :no  =>  'NORWEGIAN'      ,  
                :oc  =>  'OCCITAN'        ,  
                :om  =>  'AFAN'           ,
                :or  =>  'ORIYA'          ,  
                :pa  =>  'PUNJABI'        ,  
                :pl  =>  'POLISH'         ,  
                :ps  =>  'PASHTO'         ,
                :pt  =>  'PORTUGUESE'     ,  
                :qu  =>  'QUECHUA'        ,  
                :rm  =>  'RHAETO-ROMANCE' ,  
                :rn  =>  'KURUNDI'        ,  
                :ro  =>  'ROMANIAN'       ,  
                :ru  =>  'RUSSIAN'        ,  
                :rw  =>  'KINYARWANDA'    ,  
                :sa  =>  'SANSKRIT'       ,  
                :sd  =>  'SINDHI'         ,  
                :sg  =>  'SANGHO'         ,  
                :sh  =>  'SERBO-CROATIAN' ,  
                :si  =>  'SINGHALESE'     ,  
                :sk  =>  'SLOVAK'         ,  
                :sl  =>  'SLOVENIAN'      ,  
                :sm  =>  'SAMOAN'         ,  
                :sn  =>  'SHONA'          ,  
                :so  =>  'SOMALI'         ,  
                :sq  =>  'ALBANIAN'       ,  
                :sr  =>  'SERBIAN'        ,  
                :ss  =>  'SISWATI'        ,  
                :st  =>  'SESOTHO'        ,  
                :su  =>  'SUNDANESE'      ,  
                :sv  =>  'SWEDISH'        ,  
                :sw  =>  'SWAHILI'        ,  
                :ta  =>  'TAMIL'          ,  
                :te  =>  'TELUGU'         ,  
                :tg  =>  'TAJIK'          ,  
                :th  =>  'THAI'           ,  
                :ti  =>  'TIGRINYA'       ,  
                :tk  =>  'TURKMEN'        ,  
                :tl  =>  'TAGALOG'        ,  
                :tn  =>  'SETSWANA'       ,  
                :to  =>  'TONGA'          ,  
                :tr  =>  'TURKISH'        ,  
                :ts  =>  'TSONGA'         ,  
                :tt  =>  'TATAR'          ,  
                :tw  =>  'TWI'            ,  
                :ug  =>  'UIGUR'          ,  
                :uk  =>  'UKRAINIAN'      ,  
                :ur  =>  'URDU'           ,  
                :uz  =>  'UZBEK'          ,  
                :vi  =>  'VIETNAMESE'     ,  
                :vo  =>  'VOLAPUK'        ,  
                :wo  =>  'WOLOF'          ,  
                :xh  =>  'XHOSA'          ,  
                :yi  =>  'YIDDISH'        ,   
                :yo  =>  'YORUBA'         ,  
                :za  =>  'ZHUANG'         ,  
                :zh  =>  'CHINESE'        ,  
                :zu  =>  'ZULU'      
              }
              
  def self.parse_http_accept_language(lang)
    return nil if lang.nil?
    # I'm sure there's a more elegant way of doing this
    language_codes = lang.split(/,|;/).collect {|e| e.strip.match(/^(..)(-.*){0,1}$/)[1] rescue nil}
    language_codes.collect! {|lc| self.parse_language_code(lc) }.uniq!
  end
  
  def self.parse_language_code(code)
      LANGUAGES[code.downcase.to_sym].capitalize rescue nil
  end
  
  def self.parse_family(uagent)
      # second attempt at parsing a user-agent string into a browser family.
      # possibly belongs in browser.rb, and another method written for bots in bot.rb
      # todo: get these regexes from the db, or yaml, or something..
          
        case uagent
        when /Macintosh; .* AppleWebKit\/\d+\.\d+ [\(]KHTML[,] like.*Gecko[\)] Safari\/([\d\.]+)/m
          'Safari'
        when /^Mozilla.*[)] Gecko\/\d{8} Firefox\/([\d\.]+)?/
          'Firefox' 
        when /^Mozilla.*[\(]compatible[;] MSIE \d\.\d+[;] (Mac_PowerPC|Windows)[;]? .*[\)]/i
          'IE'
        when /^Mozilla\/4.*[^(compatible)]/
          'Netscape'  
        when /^Mozilla.* (\w+)\/([\d\.]+)[+]?$/ 
           $1
        when /^Mozilla/ # no more mozilla past this point
           'mozilla?'    
        when (/^(Opera|Lynx|Links)\/([\d\.]+)/)
           $1
        # real result in log - Dreamer3 
        when (/^(Links) \(.+\)/)
           $1 
        else
           'unknown'
        end
  end
  
  def self.parse_version(uagent)
      # try to find the version. most browsers its fairly simple, the platform
      # family precedes the version. there are a few special cases, first:
      case parse_family(uagent)
      when 'Netscape'
        return uagent.match(/Mozilla\/([\d\.]+)/)[1]
      when 'Safari'
        version = uagent.match(/Safari\/([\d\.]+)/)[1]
        safari_versions = {
          '48' => '0.8',
          '51' => '0.8.1',
          '60' => '0.8.2',
          '73' => '0.9',
          '74' => '1.0b2v74',
          '85' => '1.0',
          '85.7' => '1.0.2',
          '85.8' => '1.0.3',
          '100' => '1.1',
          '100.1' => '1.1.1',
          '125' => '1.2',
          '125.1' => '1.2.1',
          '125.7' => '1.2.2',
          '125.8' => '1.2.2',
          '125.9' => '1.2.3',
          '125.11' => '1.2.4',
          '125.12' => '1.2.4',
          '312' => '1.3',
          '312.3' => '1.3.1',
          '412' => '2.0',
          '412.2' => '2.0',
          '412.5' => '2.0.1' }
  
        return safari_versions[ version ] if safari_versions.keys.include? version
        # not found? some weird minor rev. go fuzzy!
        if version =~ /\d+\.\d+$/
          rex = version.gsub(/\.\d+$/, "")
          return safari_versions[ rex ] if safari_versions.keys.include? rex
        end
        return '>1.2' if version.to_i > 125
        return '<1.0' if version.to_i < 85
      when 'IE'
        return uagent.match(/MSIE ([\d\.]+)/)[1]
      else
        #firefox, icab, camino, opera, omniweb, konqueror, lynx, etc
        # rescue here is a little bad form, but, for stupid stuff like "MonkeyWare"
        # then this will fall back.
        return uagent.match(/#{parse_family(uagent)}( |\/)([\d\.]+)/)[2] rescue 'Unknown'
      end    
  end
  
before_save :convert_languages, :parse_stuff

def convert_languages
self.http_accept_language = Stat.parse_http_accept_language(self.http_accept_language)
end


def parse_stuff
      self.browser = Stat.parse_family(self.http_user_agent)
      self.browser_version = Stat.parse_version(self.http_user_agent)
   end
   
end
