class Tag < ActiveRecord::Base
has_and_belongs_to_many :pages

validates_presence_of :name
validates_uniqueness_of :name
before_save :transform_html

def self.prune_tags
    find(:all).each { |t| t.destroy if t.pages.size == 0 }
end
  

def self.cloud
self.find_by_sql(["
	             SELECT tags.id, tags.name, COUNT(pages_tags.page_id) AS page_counter
		     FROM #{Tag.table_name} tags LEFT OUTER JOIN #{Tag.table_name_prefix}pages_tags#{Tag.table_name_suffix} pages_tags
	             ON pages_tags.tag_id = tags.id
                     LEFT OUTER JOIN #{Tag.table_name_prefix + Page.table_name + Tag.table_name_prefix} pages
                     ON pages_tags.page_id = pages.id
                     GROUP BY tags.id, tags.name
      		     ORDER BY page_counter DESC
		 "]).each{|tag| tag.page_counter = tag.page_counter.to_i }
end

protected
  
  def transform_html
      self.description_html = HtmlEngine.transform(description, self.text_filter)
  end

end
